<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Handle shipping calculation
'*********************************************************************************

dim ShipMethod
dim ShipCost
dim ShippingMethods(50)

'6.00 - Nov 12,2005
dim shippingvalues(50), tempvalue

dim ShippingCount
dim CalculationType
dim shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
const productcostfield = "weight" ' set to other field if necessary
const shipcountrydefault = "other" ' set for other country
const shipstatedefault = "None" ' set for other country

sub UpdateShippingSessionData()
   ' called from shop customer to process form and get shipping price
   dim optionname
   dim optionPrice
   dim rc
   SetSess "shipname", strshipname
   SetSess "shipcompany", strshipcompany
   SetSess "shipaddress", strshipaddress
   SetSess "shiptown", strshiptown
   SetSess "shipzip", strshipzip
   SetSess "shipstate", strshipstate
   SetSess "shipcountry", strshipcountry
   SetSess "shipmessage", ""

   '6.09 Security Fix
   ShipMethodType = CleanChars(Request.form("ShipMethodType"))
   if shipmethodtype = "" then
      shipmethodtype = GetConfig("xfixedshippingmethod")
   end if
   SetSess("Shipmethodtype"), Shipmethodtype
   ParseOption ShipMethodType, ShipMethod, ShipCost
   
   '701 - 2011.04.27 - Bug Fix: Should not display not-related contents if using paypal express checkout
   'DebugWrite "shipmethodtype="& shipmethod & "shipcost=" & shipcost
   
   SetSess "ShipMethod", Shipmethod

   '701 - 2011.05.18 - Better handling with Ajax Shipping
   if getsess("Newcurrencysymbol")<>"" and Shipcost<>"" then
	  shipcost = replace(shipcost, getsess("Newcurrencysymbol"), "")
      if GetSess("Conversionvalue") <> 1 then
	     ShipCost = ShipCost / GetSess("Conversionvalue")
      end if
   end if

   SetSess "smprice", ShipCost
   HandleFreeShipping rc
   if rc = 0 then
      exit sub
   end if
   
   ' VP-ASP 600 - Handle Other shipping 20/10/2005
   dim othershipsql, othershiprs
   othershipsql = "Select * from shipmethods where shipmethod='" & shipmethod & "'"
   AddShippingCountry othershipsql, othershiprs, dbc
   if not othershiprs.eof then
      if othershiprs("shiproutine") > "" then
         SetSess "ShipCalc", "OTHER"
         SetSess "followonURL", othershiprs("shiproutine")
         othershiprs.close
         set othershiprs = nothing
         exit sub
      end if
   else
      '701 - 2011.05.18 - Better handling with Ajax Shipping
      exit sub
   end if
   othershiprs.close
   set othershiprs = nothing
   CalculateShipping ' all others handled differently
   if GetConfig("xDeliveryShipping") = "Yes" then
      DeliveryShippingCalc ' handle delivery shipping
   end if
end sub

' Save all the other routines the trouble by recalculating cost, weight, weight
sub CalculateShipping
   LocateShippingRecord dbc, Shipmethod ' get shipping record
   CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
   Calculationtype = ucase(GetConfigvalue("xShippingCalc")) ' What type of calculation are we doing
   if Calculationtype = "" then exit sub
   select case CalculationType
      Case "LOOKUP"
         HandlebyLookup
      case "WEIGHT"
         HandlebyWeight
      case "QUANTITY"
         HandlebyQuantity
      case "WEIGHTRANGE"
         HandlebyWeightRange
      case "PRICERANGE"
         HandlebyPriceRange
      case "FIXED"
         HandlebyFixed
      case "PRODUCT"
         HandlebyProduct
      case "QUANTITYRANGE"
         HandlebyQuantityrange
      case "MESSAGE"
         HandlebyMessage
      case "OTHER"
         HandlebyOther
      case "PRICEPERCENT"
         HandlebyPricePercent
      case else
         SError = "Unknown Shipping Method"
   end select
end sub

' Read Database and store dat in shippingmethods array
' because of curreny conversion there are two arrays
' shippingmethods is the display portion in current currency
' shippingvalues is the original price
sub GetShippingDatabase
   dim rsship
   dim TempOption, tempdisplay, tempvalue
   dim TempPrice
   dim prevMethod
   shippingcount = 0
   prevmethod = ""
   set rsship = Server.createobject ("ADODB.Recordset")

      SQL = "SELECT * from shipmethods order by shipmethod"
   
   rsship.open SQL, dbc, adOpenForwardOnly, adLockReadOnly, adCmdText
   do while not rsship.eof
      TempOption = ""
      TempValue = ""
      TempPrice = ""
      TempOption = rsship("shipmethod")
      TempPrice = rsship("smprice")
      Tempdisplay = tempoption
      tempvalue = tempoption
      if TempOption<>PrevMethod then
         if GetConfig("xdisplayprices") = "No" then
            TempPrice = ""
         end if
         if TempPrice<>"" then
            if TempPrice<>0 then
			   if getconfig("xshippingbycountry") = "No" then
                  TempDisplay = TempOption & " [" & ShopFormatCurrency(TempPrice, GetConfig("xdecimalpoint")) & "]"
                  TempValue = TempOption & " [" & formatnumber(TempPrice, GetConfig("xdecimalpoint")) & "]"
               else
                  TempDisplay= TempOption
                  TempValue= TempOption
			   end if
			   if getconfig("Xshippingbystate") = "No" then
                  TempDisplay = TempOption & " [" & ShopFormatCurrency(TempPrice, GetConfig("xdecimalpoint")) & "]"
                  TempValue = TempOption & " [" & formatnumber(TempPrice, GetConfig("xdecimalpoint")) & "]"
               else
                  TempDisplay= TempOption
                  TempValue= TempOption
			   end if
            end if
         end if
         ShippingMethods(shippingcount) = TempDisplay
         shippingvalues(shippingcount) = Tempvalue
      end if
      PrevMethod = TempOption
      if ShippingCount = 0 then
         if GetSess("Shipmethodtype")<>"" then
            shipmethodtype = GetSess("shipmethodtype")
         else
            ShipMethodType = ShippingMethods(0) ' set defaut method
         end if
      end if
      shippingcount = shippingcount + 1
      rsship.MoveNext
   loop
   CloseRecordSet rsship
end sub

' gets one shipping method from Database
sub LocateShippingRecord (dbc, Shipmethod)
   dim shipsql
   dim i
   ' Reread Database record for a particular method
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   shipsql = "select * from shipmethods where shipmethod="& sqlserverprefixn &"'" & shipmethod & "'"
   AddShippingCountry shipsql, objrs, dbc

   if objRS.eof then
      '6.09 - fix for shipping displaying error inappropriately
      select case ucase(GetConfig("xshippingcalc"))
         case "FIXED"
            cursmprice = ShopFormatCurrency(GetConfig("xfixedshippingcost"), GetConfig("xdecimalpoint"))
            Shipmethod = ucase(GetConfig("xshippingcalc")) & " " & cursmprice
            ShipCost = curSmprice
            SetSess "shipmessage", shipmethod
            SetSess "shipselectionerror", ""
         case "PRODUCT"
            Shipmethod = ""
            SetSess "shipmessage", shipmethod
            SetSess "shipselectionerror", ""
         case else
	        '700 - AJAX Shipping Calculation
   	        Shipmethod = ""
            SetSess "shipmessage", shipmethod
      end select
   else
      lngshipmethodid = objrs("shipmethodid")
      strshipmethod = objrs("shipmethod")
      cursmprice = objrs("smprice")
      curshipbasecost = objrs("shipbasecost")
      curshipextracost = objrs("shipextracost")
      if isnull(curshipbasecost) then
         curshipbasecost = 0
      end if
      if isnull(curshipextracost) then
         curshipextracost = 0
      end if
      strshipother1 = objrs("shipother1")
      strshipother2 = objrs("shipother2")
      curshipcost2 = objrs("shipcost2")
      curshipcost1 = objrs("shipcost1")
      ShipCost = curSmprice
   end if
   CloseRecordSet objrs
end sub

' ShipMethod. Get total weight
' Base Cost + extracost*weight
sub HandleByWeight
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim ShippingCost
   if shiptotalweight = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = 0
   if not isnull(curshipbaseCost) then
      TotalPrice = curShipBaseCost
   end if

   ShipCost = CurShipExtraCost
   ShippingPrice = shipTotalWeight * ShipCost
   TotalPrice = ShippingPrice + TotalPrice
   'Fix bug: base price added to shipcost
   ShipCost = TotalPrice

   SetSess "smprice", TotalPrice
   SetSess "ShipMethod", ShipMethod
   SetSess "shipcalc", "Weight"
end sub

' ShipMethod
' ShipCost
' The weight field in the Database actually has product shipping cost
sub HandleByProduct
   dim rssql
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim Prodid, prodquantity
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      prodid = ArrCart(cProductid, i)
      Prodquantity = ArrCart(cQuantity, i)
      rssql = "Select * from products where CatalogId=" & prodid
      if GetConfig("xshippingfreeproducts") = "Yes" then
         rssql = rssql & " and (freeshipping=0 or freeshipping is null)"
      end if
      Set rsitem = Server.CreateObject("ADODB.Recordset")
      rsitem.open rssql, dbc, adOpenDynamic, adLockOptimistic
      if not rsItem.eof then
         shippingcost = rsitem(ProductCostField)
         if isnull(shippingcost) then
            shippingcost = 0
         end if
         ShippingPrice = shippingcost * prodquantity
         TotalPrice = ShippingPrice + TotalPrice

         'Fix bug: base price added to shipcost
         ShipCost = TotalPrice

         if GetConfig("xdebug") = "Yes" then
            DebugWrite "ShippingPerItem=" & ShippingCost & " quantity=" & prodquantity
            DebugWrite "shippingPrice=" & ShippingPrice
            DebugWrite "total=" & Totalprice
         end if
      end if
      rsitem.close
      set rsitem = nothing
   next
   SetSess "smprice", TotalPrice
end sub

' Use number of items as shipping calculation
' QuantityBase = base shipping Price
' QuantityExtra= Extra amount per item
sub HandleByQuantity
   dim prodid, prodcode, prodname, Prodquantity, ProdPrice
   dim i, calculate
   dim ShippingPrice
   dim TotalPrice
   dim QuantityExtra, DEliveryArray
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = 0 ' from Database
   QuantityExtra = curShipExtracost ' extra per unit
   if isnull(QuantityExtra) then
      QuantityExtra = 0
   end if
   TotalPrice = curShipBaseCost ' base amount
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      prodid = ArrCart(cProductid, i)
      prodcode = ArrCart(cProductCode, i)
      prodname = ArrCart(cProductname, i)
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      Deliveryarray = ArrCart(cDelivery, i)
      Calculate = CheckDeliverySelf(deliveryArray)
      if calculate = True then
         Calculate = CheckDeliveryFree(dbc, prodid)
         if calculate = True then
            ShippingPrice = prodquantity * QuantityExtra
            TotalPrice = ShippingPrice + TotalPrice
         end if
      end if
      if GetConfig("xdebug") = "Yes" then
         DebugWrite "ExtraPerItem=" & QuantityExtra & " quantity=" & prodquantity
         DebugWrite "shippingPrice=" & ShippingPrice
         DebugWrite "total=" & Totalprice
      end if
   next
   SetSess "smprice", TotalPrice
   SetSess "ShipMethod", ShipMethod
   SetSess "shipcalc", "Quantity"
end sub

' Use numer of items as shipping calculation
' Calculate fill Price
sub HandleByPriceRange
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim rsitems
   dim lowvalue, highvalue
   dim shipsql
   if shiptotalcost = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   TotalPrice = shiptotalcost
   if GetConfig("Xdeliveryshipping") = "Yes" then
      CalculateTotalPrice dbc, totalprice
      if totalprice = 0 then
         exit sub
      end if
   end if

   ' Find the weight range using shipother1 and shipother2
   ' Reread Database record for a particular method
   shipsql = "select * from shipmethods where shipmethod='" & shipmethod & "'"
   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowvalue = rsitems("shipcost1")
      highvalue = rsitems("shipcost2")
      if totalprice >= lowvalue and totalprice < highvalue then
         shipcost = rsitems("shipbasecost")
         CloseRecordSet rsitems
         SetSess "smprice", ShipCost
         exit sub
      end if
      rsitems.movenext
   loop
   ShipCost = 0
   CloseRecordSet rsitems
   SetSess "smprice", ""
   SetSess "ShipCalc", "Price Range"
end sub

' Use numer of items as shipping calculation
' Calculate weight on product id
' If shipother1 set then use extra when weight exceeds
' Shipother1=LowWeight Range
' ShipOther2=highweightrange
' ShipBasecost=cost in that range
' Shipextracost  if weight exceeds low range
' shipmethod	smprice	ShipBaseCost	ShipExtraCost	ShipOther1   ShipOther2
' GROUND		      $8.50	           $2.00	          0   		100
' 2nd DAY AIR		$18.50	        $3.00	          2
' Next Day Air		$35.50	        $3.50	          2
' International	$49.50	        $9.00	          2
sub HandleByWeightRange
   dim weight
   dim i
   dim ShippingPrice
   dim TotalPrice
   dim rsitem
   dim ShippingCost
   dim TotalWeight
   dim totalfeatureweight
   TotalWeight = 0
   TotalPrice = 0 ' set base price from Database or a constant
   if GetConfig("XdeliveryAddress") = "Yes" and shipTotalweight = 0 then exit sub
   totalweight = shiptotalweight
   LocateShippingWeightRange shipmethod, TotalWeight
end sub

' read all records with specific ship method name
' See which falls into weight range calculation
sub LocateShippingWeightRange (Shipmethod, Totalweight)
   dim rsitems
   dim lowweight, highweight
   dim addprice
   dim Extraweight
   dim ExtraPrice
   dim TotalPrice
   SetSess "ShipCalc", "Weight Range"
   ' Find the weight range using shipother1 and shipother2
   SetSess "Shipmethod", Shipmethod
   dim shipsql
   ' Reread Database record for a particular method
   shipsql = "select * from shipmethods where shipmethod='" & shipmethod & "'"
   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowweight = rsitems("shipother1")
      highweight = rsitems("shipother2")
      if not isnull(lowweight) then
         lowweight = csng(lowweight)
      end if
      if not isnull(highweight) then
         highweight = csng(highweight)
      end if
      if totalweight >= lowweight and Totalweight <= highweight then
         ShipCost = rsitems("ShipBaseCost")
         Extraweight = totalweight - Lowweight
         extraprice = rsitems("shipextracost")
         AddPrice = 0
         if not isnull(Extraprice) then
            if Extraweight>0 then
               AddPrice = ExtraWeight * ExtraPrice
            end if
         end if
         TotalPrice = ShipCost + AddPrice
         rsitems.close
         set rsitems = nothing
         SetSess "smprice", TotalPrice
         exit sub
      end if
      rsitems.movenext
   loop
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then ShipCost = 99999.99
   
   rsitems.close
   set rsitems = nothing
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then
      SetSess "smprice", ShipCost
      SetSess "shipselectionerror", "weight"
   end if

   '700 - 2010.06.03 - Enhancement: Better shipping calculation error handling
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then shoperror "Shipping is out of range or mis-configure.<br />Please contact administrator for further assistance."
end sub

' if therte is no quantity then even fixed has no cost
sub HandleByFixed
   ' Need to add xshippingmethod and xshipping cost to shop$config for this to work
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   ShipMethod = GetConfig("xFixedShippingMethod")
   SetSess "smprice", GetConfig("xFixedShippingCost")
   SetSess "ShipMethod", GetConfig("xFixedShippingMethod")
end sub

' This allows a totally extendable shipping system by allowing the
' routine to be specified in the Database
sub HandlebyOther
   dim ShipSql, shipmethod, shiprs, routine
   if shiptotalquantity = 0 then
      'SetSess "smprice", 0
      exit sub
   end if
   shipmethod = GetSess("shipmethod")
   shipsql = "Select * from shipmethods where shipmethod='" & shipmethod & "'"
   AddShippingCountry shipsql, shiprs, dbc

   if not shiprs.eof then
      routine = shiprs("shiproutine")
      if not isnull(routine) then
         SetSess "followonURL", routine
      end if
   end if
   ' no routine name treat as lookup
   shiprs.close
   set shiprs = nothing
end sub

sub CalculateTotalPrice(dbc, TotalPrice)
   dim Prodquantity, ProdPrice, deliveryarray, i, price, prodid
   dim scartiten, ArrCart
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   dim Calculate
   ' go through all products
   totalprice = 0
   for i = 1 to scartItem
      calculate = True
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      DeliveryArray = ArrCart(cDelivery, i)
      prodid = ArrCart(cProductid, i)
      Calculate = CheckDeliverySelf(deliveryArray)
      if Calculate = True then
         calculate = CheckDeliveryfree (dbc, prodid)
         if calculate = true then
            Price = ProdPrice * ProdQuantity
            totalprice = totalprice+price
         end if
      end if
   next
end sub

function CheckDeliverySelf (deliveryArray)
   ' Returns tru if to calculate this product
   dim DeliveryType
   CheckDeliverySelf = True
   if GetConfig("Xdeliveryshipping")<>"Yes" then exit function
   if isarray(deliveryarray) then
      Deliverytype = Deliveryarray(dDeliveryType)
      if Deliveryarray(dDeliveryType)<>GetLang("LangDeliverySelf") then
         CheckDeliverySelf = False
      end if
   end if
end function

' Quantity range calculation
sub HandleByQuantityRange
   dim Totalquantity
   Totalquantity = 0
   if shiptotalquantity = 0 then exit sub
   GetProductQuantity TotalQuantity ' total weight of product
   if Totalquantity = 0 then exit sub
   LocateShippingQuantityRange shipmethod, totalQuantity
end sub

sub GetProductQuantity( TotalQuantity )
   dim scartitem, ArrCart, i, prodquantity, deliveryarray, calculate
   dim prodprice, Deliverytype
   totalquantity = 0
   scartItem = GetSess("CartCount")
   ArrCart = GetSessA("CartArray")
   ' go through all products
   for i = 1 to scartItem
      Calculate = True
      Prodquantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      DeliveryArray = ArrCart(cDelivery, i)
      if GetConfig("Xdeliveryshipping") = "Yes" and isarray(deliveryarray) then
         Deliverytype = Deliveryarray(dDeliveryType)
         if Deliveryarray(dDeliveryType)<>GetLang("LangDeliverySelf") then
            Calculate = False
         end if
      end if
      if calculate = True then
         totalquantity = totalquantity + prodquantity
      end if
   next
end sub

sub LocateShippingQuantityRange (Shipmethod, TotalQuantity)
   dim rsitems
   dim lowweight, highweight
   dim addprice
   dim Extraweight
   dim ExtraPrice
   dim TotalPrice
   SetSess "ShipCalc", "Quantity Range"
   ' Find the quantity range using shipother1 and shipother2
   SetSess "Shipmethod", Shipmethod
   dim shipsql
   ' Reread Database record for a particular method
   shipsql = "select * from shipmethods where shipmethod='" & shipmethod & "'"
   AddShippingCountry shipsql, rsitems, dbc

   do while not rsitems.eof
      lowweight = rsitems("shipother1")
      highweight = rsitems("shipother2")
      if not isnull(lowweight) then
         lowweight = csng(lowweight)
      end if
      if not isnull(highweight) then
         highweight = csng(highweight)
      end if
      if totalquantity >= lowweight and Totalquantity <= highweight then
         shipcost = rsitems("shipbasecost")
         Extraweight = totalquantity - Lowweight
         extraprice = rsitems("shipextracost")
         AddPrice = 0
         if not isnull(Extraprice) then
            if Extraweight>0 then
               AddPrice = ExtraWeight * ExtraPrice
            end if
         end if
         TotalPrice = ShipCost + AddPrice
         CloseRecordSet rsitems
         SetSess "smprice", TotalPrice
         exit sub
      end if
      rsitems.movenext
   loop

   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then ShipCost = 99999.97

   CloseRecordSet rsitems
   
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then 
      SetSess "smprice", ShipCost
      SetSess "shipselectionerror", "quantity"
   end if

   '700 - 2010.06.03 - Enhancement: Better shipping calculation error handling
   '700 - 2010.08.05 - Bug Fix: Able to return to other special shipping routine if no result
   if trim(shipmethod) <> "" then shoperror "Shipping is out of range or mis-configure.<br />Please contact administrator for further assistance."
end sub

sub GetProductRecord (dbc, rsitem, prodid)
   dim shipsql
   ShipSql = "Select * from products where CatalogId=" & prodid
   Set rsitem = Server.CreateObject("ADODB.Recordset")
   rsitem.open shipsql, dbc, adOpenDynamic, adLockOptimistic
end sub

' a shipping message is to be displayed
sub HandleByMessage
   'SetSess "smprice", 0
   SetSess "shipmessage", GetLang("LangShippingMessage")
end sub

' a shipping message is to be displayed
sub HandleFreeShipping (rc)
   '701 - 2012.02.24 - Bug Fix: Free shipping message should always initial and only show at shopcreateorder.asp
   SetSess "shipmessage", ""

   dim shipcost, productcost
   rc = 4
   if GetConfig("xshippingfree")<>"" then
      shipcost = GetConfig("xshippingfree")
      if isnumeric(shipcost) then
         shipcost = csng(shipcost)
         productcost = GetSess("orderproducttotal")
         productcost = csng(productcost)
         if productcost>= shipcost then
            SetSess "smprice", 0
            SetSess "shipmessage", GetLang("LangFreeShippingMessage")
            rc = 0
            exit sub
         end if
      end if
   end if
   if GetConfig("xshippingfreeproducts") = "Yes" then
      CalculateShippingdetails dbc, shiptotalWeight, shiptotalfeatureweight, shiptotalcost, shiptotalquantity
      if shiptotalcost = 0 then
	     '700 - 2010.05.14 - Bug Fix: Free shipping with product is not working with shipping addon
	     session("currentfreeshippingstatus") = "Yes"

         SetSess "smprice", 0
         rc = 0
         exit sub
      end if
   end if
end sub

' if doing country shipping then add country to supplied sql
' if we do not find any records, try using a default shipicountry of other
sub AddShippingCountry (shipsql, rs, dbc)
   dim shipcountry, tempsql
   tempsql = shipsql
   if GetConfig("xshippingbycountry") = "Yes" then
      shipcountry = GetSess("shipcountry")
      if shipcountry = "" then
         shipcountry = GetSess("country")
      end if
      if shipcountry<>"" then
	     '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
         tempsql = shipsql & " and shipcountry="& sqlserverprefixn &"'" & shipcountry & "'"
      end if
   end if
   
   'set rs = dbc.execute(tempsql)
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open tempsql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then exit sub
   CloseRecordSet rs
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   tempsql = shipsql & " and (shipcountry="& sqlserverprefixn &"'" & shipcountrydefault & "'"
   
   tempsql = tempsql & " ) "
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open tempsql, dbc, adOpenDynamic, adLockOptimistic
   if rs.eof and ucase(getconfig("xshippingcalc")) <> "LOOKUP" and ucase(getconfig("xshippingcalc")) <> "FIXED" and ucase(getconfig("xShippingCalc")) <> "PRODUCT" then
      'HandleShippingError tempsql
   end if
end sub

sub HandleShippingError (shipsql)
   dim shipmethod
   Shipmethod = "Cannot locate shipping record<br />" & shipsql
   SetSess "shipmessage", shipmethod
   SetSess "shipselectionerror", "country"
end sub

' xfixedshippingcost is used as a percent value
sub HandleByPricePercent
   dim TotalPrice, percent, shippingcost
   TotalPrice = GetSess("OrderProductTotal")
   percent = GetConfig("xFixedShippingCost")
   if not isnumeric(percent) then exit sub
   percent = csng(percent)
   shippingcost = totalprice * percent
   shippingcost = formatnumber(shippingcost, 2)
   SetSess "smprice", shippingcost
end sub

Sub HandleByLookup
   dim ShipSql, shipmethod, shiprs, shipcost
   shipmethod=Getsess("shipmethod")
   shipsql="Select * from shipmethods where shipmethod='" & shipmethod & "'"
   
   '700 - 2010.09.01 - Bug Fix: Possible Error while shipping with paypal express
   'ShopOpendatabase dbc
   
   AddShippingCountry shipsql,shiprs, dbc

   If not shiprs.eof then 
      shipcost= shiprs("smprice")
   End If
   
   '700 - 2010.09.01 - Bug Fix: Possible Error while shipping with paypal express
   'ShopCloseDatabase dbc
   
   SetSess "smprice",ShipCost
   SetSess "ShipCalc","LOOKUP"
end sub
%>